jQuery(document).ready(function($){
	var admin = {
			init: function(){
				$('.button-collapse').sideNav();
				//$('select').filter(':not(.bfwc-select2)').material_select();
				
				$('select').select2();
				
				$('.modal-trigger').leanModal();
				
				$('.bfwc-close-modal').on('click', this.close_modal);
				
				$('.add-chip-setting').on('click', this.add_chip_setting);
				
				$('.remove-settings-chip').on('click', this.close_meta_chip);
				
				$('#braintree_checkout_settings_custom_form_design').on('change', this.custom_form_style_change);
				
				$('select').on('change', this.show_child_settings);
				
				$('.add-merchant-account').on('click', this.add_merchant_account);
				
				$('.trash-merchant-account').on('click', this.remove_merchant_account);
				
				$('input[type="checkbox"]').on('change', this.uncheck_opposite);
				
				$('#braintree_checkout_settings_paypal_only').on('change', this.show_paypal_options);
				
				$('button.btn').on('click', this.show_loader);
				
				this.show_child_settings();
				
				this.disable_if_inactive();
				
				this.show_paypal_options();
				
				this.prepare_multiselect();
			},
			close_admin_notice: function(e){
				e.preventDefault();
				$(this).parent('div').slideUp().remove();
			},
			add_chip_setting: function(e){
				e.preventDefault();
				var option, html, title, fieldKey;
				fieldKey = $(this).attr('field-key');
				option = $($(this).attr('select-id')).val();
				title = braintree_settings_vars.keys[fieldKey].options[option];
				html = braintree_settings_vars.keys[fieldKey].html.replace('%title%', title);
				html = html.replace('%name%', option);
				if($('input[name="'+fieldKey + '['+option+']"]').length > 0){
					Materialize.toast(braintree_settings_vars.keys[fieldKey].toast.replace('%s', title), 2000, 'red lighten-2');
					return;
				}
				var parent = $(this).parent().parent('.row');
				var next = parent.find('div.chip-settings-container');
				next.append(html);
				$('.remove-settings-chip').on('click', this.close_meta_chip);
			},
			custom_form_style_change: function(){
				var form = $(this).val();
				$('#braintree_checkout_settings_custom_form_styles').val(braintree_settings_vars.custom_forms[form].styles);
			},
			show_child_settings: function(e){
				$('select').each(function(){
					var val = $(this).val();
					var element = $(this);
					$('[data-parent-setting]').each(function(){
						if($(this).attr('data-parent-setting') === element.attr('id')){
							if($(this).attr('data-show-if') === val){
								$(this).closest('tr').show();
							}else{
								$(this).closest('tr').hide();
							}
						}
					})
				})
			},
			disable_if_inactive: function(){
				if($('#braintree_gateway_license_status').val() !== 'active'){
					$('.production-option').prop('disabled', true);
				}
			},
			add_merchant_account: function(e){
				e.preventDefault();
				var currency, environment, html, name, row;
				currency = $($(this).attr('select-id')).val();
				if(currency == null){
					Materialize.toast(braintree_settings_vars.merchant_accounts.messages.no_currency, 2500, 'red lighten-2');
					return;
				}
				environment = $(this).attr('environment');
				name = $(this).attr('data-setting').replace('%currency%', currency);
				if($('input[name="'+name+'"]').length > 0){
					Materialize.toast(braintree_settings_vars.merchant_accounts.messages.currency_exists.replace('%currency%', currency), 2500, 'red lighten-2');
					return;
				}
				html = braintree_settings_vars.merchant_accounts[environment].html.replace('%currency%', currency).replace('%name%', name);
				row = $(this).closest('.row');
				row.append(html);
				$('.trash-merchant-account').on('click', admin.remove_merchant_account);
			},
			remove_merchant_account: function(){
				var element = $(this).closest('.col');
				$(this).closest('.col').fadeOut(400, function(){
					element.remove();
				})
			},
			uncheck_opposite: function(){
				var id;
				if($(this).is(':checked')){
					$($(this).attr('uncheck')).prop('checked', false);
				}
			},
			show_paypal_options: function(e){
				if($('#braintree_checkout_settings_paypal_only').is(':checked')){
					$('tr.paypal_options').show();
				}else{
					if($('#braintree_checkout_settings_checkout_form').val() !== 'custom_form'){
						$('tr.paypal_options').hide();
					}
				}
			},
			show_loader: function(){
				$(this).children('div.preloader-wrapper').show();
			},
			close_modal: function(){
				$(this).closest('.modal').closeModal();
			},
			prepare_multiselect: function(){
				$('.bfwc-multiselect').select2();
			}
	}
	admin.init();
})