<?php

class Braintree_Gateway_Admin_Order_Metabox
{

	public function __construct()
	{
		add_action( 'add_meta_boxes', array (
				$this, 
				'add_metaboxes' 
		) );
		add_action( 'admin_enqueue_scripts', array (
				$this, 
				'enqueue_scripts' 
		) );
		add_action( 'woocommerce_admin_order_data_after_order_details', array (
				$this, 
				'output_status' 
		) );
	}

	public function add_metaboxes()
	{
		add_meta_box( 'braintree-woocommerce-settlement-amount', __( 'Capture Amount', 'braintree' ), array (
				$this, 
				'output_settlement' 
		), 'shop_order', 'side' );
	}

	public function output_settlement( $post )
	{
		include bt_manager()->plugin_admin_path() . 'meta-box-html/order-settlement.php';
	}

	/**
	 *
	 * @param WC_Order $order        	
	 */
	public function output_status( $order )
	{
		if ( ! in_array( $order->payment_method, bwc_get_payment_gateways() ) ) {
			return; // This order is not a braintree order.
		}
		
		if ( get_class( $order ) !== 'WC_Order' ) {
			return;
		}
		
		global $braintree_transaction;
		
		$id = $order->get_transaction_id();
		
		if ( empty( $id ) ) {
			return;
		}
		
		if ( ! $braintree_transaction ) {
			try {
				$braintree_transaction = Braintree_Transaction::find( $id );
			} catch( \Braintree\Exception $e ) {
				return;
			}
		}
		echo '<p class="form-field form-field-wide"><label for=""> ' . __( 'Braintree Transaction Status', 'braintree' ) . '</label><p>' . strtoupper( $braintree_transaction->status ) . '</p>';
	}

	public function enqueue_scripts()
	{
		global $post;
		if ( ! is_admin() || ! $post ) {
			return;
		}
		$action = isset( $_REQUEST [ 'action' ] ) ? $_REQUEST [ 'action' ] : '';
		if ( $post->post_type === 'shop_order' && $action === 'edit' ) {
			
			wp_enqueue_script( 'braintree-admin-order', bt_manager()->plugin_assets_path() . 'js/admin/order.js', array (
					'jquery' 
			), bt_manager()->version, true );
		}
	}
}
new Braintree_Gateway_Admin_Order_Metabox();