<?php
/**
 * metabox for subscription options such as start date, trial period, etc.
 */
wp_nonce_field('bfwc-subscription', '_bfwc_subscription');
?>
<div class="form-field form-field-wide">
	<h4><?php _e('Trial End Date', 'braintree')?></h4>
	<input class="date-picker" id="_subscription_trial_end_date" name="_subscription_trial_end_date" value="<?php echo $subscription->get_formatted_date('trial_end', 'Y-m-d')?>">
</div>
<div class="form-field form-field-wide">
	<h4><?php _e('Start Date', 'braintree')?></h4>
	<input class="date-picker" name="_start_date" id="_start_date" value="<?php echo $subscription->get_formatted_date('start', 'Y-m-d')?>">
</div>
<div class="form-field form-field-wide">
	<h4><?php _e('Subscription Length', 'braintree')?></h4>
	<select class="select2" id="_subscription_length" name="_subscription_length">
		<?php foreach(bfwc_subscription_length_string() as $k => $v):?>
			<option value="<?php echo $k?>" <?php selected($subscription->subscription_length, $k)?>><?php echo $v?></option>
		<?php endforeach;?>
	</select>
</div>
<div class="form-field form-field-wide">
	<h4><?php _e('Subscription Plan', 'braintree')?></h4>
	<select class="select2" id="_subscription_plan" name="_subscription_plan">
		<?php foreach($subscription_plans as $plan):?>
			<option value="<?php echo $plan['id']?>" <?php selected($subscription->braintree_plan, $plan['id'])?>><?php echo $plan['id']?></option>
		<?php endforeach;?>
	</select>
</div>
<div class="form-field form-field-wide">
	<h4><?php _e('Billing Interval', 'braintree')?></h4>
	<div>
		<span id="billing_frequency"></span>
	</div>
</div>