<?php

/**
 * Function that generates an attributes array and implodes it for use in an
 * html field.
 *
 * @param array $attributes
 * @param string $echo
 */
function bt_get_html_field_attributes( $attributes, $echo = false )
{
	$attrs = array ();
	foreach ( $attributes as $k => $v ) {
		$attrs [] = $k . '="' . $v . '"';
	}
	if ( $echo ) {
		echo implode( ' ', $attrs );
	} else {
		return implode( ' ', $attrs );
	}
}

function braintree_get_currencies()
{
	return array (
			'AED' => __( 'United Arab Emirates Dirham', 'woocommerce' ), 
			'ARS' => __( 'Argentine Peso', 'woocommerce' ), 
			'AUD' => __( 'Australian Dollars', 'woocommerce' ), 
			'BDT' => __( 'Bangladeshi Taka', 'woocommerce' ), 
			'BGN' => __( 'Bulgarian Lev', 'woocommerce' ), 
			'BRL' => __( 'Brazilian Real', 'woocommerce' ), 
			'CAD' => __( 'Canadian Dollars', 'woocommerce' ), 
			'CHF' => __( 'Swiss Franc', 'woocommerce' ), 
			'CLP' => __( 'Chilean Peso', 'woocommerce' ), 
			'CNY' => __( 'Chinese Yuan', 'woocommerce' ), 
			'COP' => __( 'Colombian Peso', 'woocommerce' ), 
			'CZK' => __( 'Czech Koruna', 'woocommerce' ), 
			'DKK' => __( 'Danish Krone', 'woocommerce' ), 
			'DOP' => __( 'Dominican Peso', 'woocommerce' ), 
			'EGP' => __( 'Egyptian Pound', 'woocommerce' ), 
			'EUR' => __( 'Euros', 'woocommerce' ), 
			'GBP' => __( 'Pounds Sterling', 'woocommerce' ), 
			'HKD' => __( 'Hong Kong Dollar', 'woocommerce' ), 
			'HRK' => __( 'Croatia kuna', 'woocommerce' ), 
			'HUF' => __( 'Hungarian Forint', 'woocommerce' ), 
			'IDR' => __( 'Indonesia Rupiah', 'woocommerce' ), 
			'ILS' => __( 'Israeli Shekel', 'woocommerce' ), 
			'INR' => __( 'Indian Rupee', 'woocommerce' ), 
			'ISK' => __( 'Icelandic krona', 'woocommerce' ), 
			'JPY' => __( 'Japanese Yen', 'woocommerce' ), 
			'KES' => __( 'Kenyan shilling', 'woocommerce' ), 
			'LAK' => __( 'Lao Kip', 'woocommerce' ), 
			'KRW' => __( 'South Korean Won', 'woocommerce' ), 
			'MXN' => __( 'Mexican Peso', 'woocommerce' ), 
			'MYR' => __( 'Malaysian Ringgits', 'woocommerce' ), 
			'NGN' => __( 'Nigerian Naira', 'woocommerce' ), 
			'NOK' => __( 'Norwegian Krone', 'woocommerce' ), 
			'NPR' => __( 'Nepali Rupee', 'woocommerce' ), 
			'NZD' => __( 'New Zealand Dollar', 'woocommerce' ), 
			'PHP' => __( 'Philippine Pesos', 'woocommerce' ), 
			'PKR' => __( 'Pakistani Rupee', 'woocommerce' ), 
			'PLN' => __( 'Polish Zloty', 'woocommerce' ), 
			'PYG' => __( 'Paraguayan Guaraní', 'woocommerce' ), 
			'RON' => __( 'Romanian Leu', 'woocommerce' ), 
			'RUB' => __( 'Russian Ruble', 'woocommerce' ), 
			'SEK' => __( 'Swedish Krona', 'woocommerce' ), 
			'SGD' => __( 'Singapore Dollar', 'woocommerce' ), 
			'THB' => __( 'Thai Baht', 'woocommerce' ), 
			'TRY' => __( 'Turkish Lira', 'woocommerce' ), 
			'TWD' => __( 'Taiwan New Dollars', 'woocommerce' ), 
			'UAH' => __( 'Ukrainian Hryvnia', 'woocommerce' ), 
			'USD' => __( 'US Dollars', 'woocommerce' ), 
			'VND' => __( 'Vietnamese Dong', 'woocommerce' ), 
			'ZAR' => __( 'South African rand', 'woocommerce' ) 
	);
}

function braintree_get_countries()
{
	return array (
			'AF' => 'Afghanistan', 
			'AX' => 'Aland Islands', 
			'AL' => 'Albania', 
			'DZ' => 'Algeria', 
			'AS' => 'American Samoa', 
			'AD' => 'Andorra', 
			'AO' => 'Angola', 
			'AI' => 'Anguilla', 
			'AQ' => 'Antarctica', 
			'AG' => 'Antigua And Barbuda', 
			'AR' => 'Argentina', 
			'AM' => 'Armenia', 
			'AW' => 'Aruba', 
			'AU' => 'Australia', 
			'AT' => 'Austria', 
			'AZ' => 'Azerbaijan', 
			'BS' => 'Bahamas', 
			'BH' => 'Bahrain', 
			'BD' => 'Bangladesh', 
			'BB' => 'Barbados', 
			'BY' => 'Belarus', 
			'BE' => 'Belgium', 
			'BZ' => 'Belize', 
			'BJ' => 'Benin', 
			'BM' => 'Bermuda', 
			'BT' => 'Bhutan', 
			'BO' => 'Bolivia', 
			'BA' => 'Bosnia And Herzegovina', 
			'BW' => 'Botswana', 
			'BV' => 'Bouvet Island', 
			'BR' => 'Brazil', 
			'IO' => 'British Indian Ocean Territory', 
			'BN' => 'Brunei Darussalam', 
			'BG' => 'Bulgaria', 
			'BF' => 'Burkina Faso', 
			'BI' => 'Burundi', 
			'KH' => 'Cambodia', 
			'CM' => 'Cameroon', 
			'CA' => 'Canada', 
			'CV' => 'Cape Verde', 
			'KY' => 'Cayman Islands', 
			'CF' => 'Central African Republic', 
			'TD' => 'Chad', 
			'CL' => 'Chile', 
			'CN' => 'China', 
			'CX' => 'Christmas Island', 
			'CC' => 'Cocos (Keeling) Islands', 
			'CO' => 'Colombia', 
			'KM' => 'Comoros', 
			'CG' => 'Congo', 
			'CD' => 'Congo, Democratic Republic', 
			'CK' => 'Cook Islands', 
			'CR' => 'Costa Rica', 
			'CI' => 'Cote D\'Ivoire', 
			'HR' => 'Croatia', 
			'CU' => 'Cuba', 
			'CY' => 'Cyprus', 
			'CZ' => 'Czech Republic', 
			'DK' => 'Denmark', 
			'DJ' => 'Djibouti', 
			'DM' => 'Dominica', 
			'DO' => 'Dominican Republic', 
			'EC' => 'Ecuador', 
			'EG' => 'Egypt', 
			'SV' => 'El Salvador', 
			'GQ' => 'Equatorial Guinea', 
			'ER' => 'Eritrea', 
			'EE' => 'Estonia', 
			'ET' => 'Ethiopia', 
			'FK' => 'Falkland Islands (Malvinas)', 
			'FO' => 'Faroe Islands', 
			'FJ' => 'Fiji', 
			'FI' => 'Finland', 
			'FR' => 'France', 
			'GF' => 'French Guiana', 
			'PF' => 'French Polynesia', 
			'TF' => 'French Southern Territories', 
			'GA' => 'Gabon', 
			'GM' => 'Gambia', 
			'GE' => 'Georgia', 
			'DE' => 'Germany', 
			'GH' => 'Ghana', 
			'GI' => 'Gibraltar', 
			'GR' => 'Greece', 
			'GL' => 'Greenland', 
			'GD' => 'Grenada', 
			'GP' => 'Guadeloupe', 
			'GU' => 'Guam', 
			'GT' => 'Guatemala', 
			'GG' => 'Guernsey', 
			'GN' => 'Guinea', 
			'GW' => 'Guinea-Bissau', 
			'GY' => 'Guyana', 
			'HT' => 'Haiti', 
			'HM' => 'Heard Island & Mcdonald Islands', 
			'VA' => 'Holy See (Vatican City State)', 
			'HN' => 'Honduras', 
			'HK' => 'Hong Kong', 
			'HU' => 'Hungary', 
			'IS' => 'Iceland', 
			'IN' => 'India', 
			'ID' => 'Indonesia', 
			'IR' => 'Iran, Islamic Republic Of', 
			'IQ' => 'Iraq', 
			'IE' => 'Ireland', 
			'IM' => 'Isle Of Man', 
			'IL' => 'Israel', 
			'IT' => 'Italy', 
			'JM' => 'Jamaica', 
			'JP' => 'Japan', 
			'JE' => 'Jersey', 
			'JO' => 'Jordan', 
			'KZ' => 'Kazakhstan', 
			'KE' => 'Kenya', 
			'KI' => 'Kiribati', 
			'KR' => 'Korea', 
			'KW' => 'Kuwait', 
			'KG' => 'Kyrgyzstan', 
			'LA' => 'Lao People\'s Democratic Republic', 
			'LV' => 'Latvia', 
			'LB' => 'Lebanon', 
			'LS' => 'Lesotho', 
			'LR' => 'Liberia', 
			'LY' => 'Libyan Arab Jamahiriya', 
			'LI' => 'Liechtenstein', 
			'LT' => 'Lithuania', 
			'LU' => 'Luxembourg', 
			'MO' => 'Macao', 
			'MK' => 'Macedonia', 
			'MG' => 'Madagascar', 
			'MW' => 'Malawi', 
			'MY' => 'Malaysia', 
			'MV' => 'Maldives', 
			'ML' => 'Mali', 
			'MT' => 'Malta', 
			'MH' => 'Marshall Islands', 
			'MQ' => 'Martinique', 
			'MR' => 'Mauritania', 
			'MU' => 'Mauritius', 
			'YT' => 'Mayotte', 
			'MX' => 'Mexico', 
			'FM' => 'Micronesia, Federated States Of', 
			'MD' => 'Moldova', 
			'MC' => 'Monaco', 
			'MN' => 'Mongolia', 
			'ME' => 'Montenegro', 
			'MS' => 'Montserrat', 
			'MA' => 'Morocco', 
			'MZ' => 'Mozambique', 
			'MM' => 'Myanmar', 
			'NA' => 'Namibia', 
			'NR' => 'Nauru', 
			'NP' => 'Nepal', 
			'NL' => 'Netherlands', 
			'AN' => 'Netherlands Antilles', 
			'NC' => 'New Caledonia', 
			'NZ' => 'New Zealand', 
			'NI' => 'Nicaragua', 
			'NE' => 'Niger', 
			'NG' => 'Nigeria', 
			'NU' => 'Niue', 
			'NF' => 'Norfolk Island', 
			'MP' => 'Northern Mariana Islands', 
			'NO' => 'Norway', 
			'OM' => 'Oman', 
			'PK' => 'Pakistan', 
			'PW' => 'Palau', 
			'PS' => 'Palestinian Territory, Occupied', 
			'PA' => 'Panama', 
			'PG' => 'Papua New Guinea', 
			'PY' => 'Paraguay', 
			'PE' => 'Peru', 
			'PH' => 'Philippines', 
			'PN' => 'Pitcairn', 
			'PL' => 'Poland', 
			'PT' => 'Portugal', 
			'PR' => 'Puerto Rico', 
			'QA' => 'Qatar', 
			'RE' => 'Reunion', 
			'RO' => 'Romania', 
			'RU' => 'Russian Federation', 
			'RW' => 'Rwanda', 
			'BL' => 'Saint Barthelemy', 
			'SH' => 'Saint Helena', 
			'KN' => 'Saint Kitts And Nevis', 
			'LC' => 'Saint Lucia', 
			'MF' => 'Saint Martin', 
			'PM' => 'Saint Pierre And Miquelon', 
			'VC' => 'Saint Vincent And Grenadines', 
			'WS' => 'Samoa', 
			'SM' => 'San Marino', 
			'ST' => 'Sao Tome And Principe', 
			'SA' => 'Saudi Arabia', 
			'SN' => 'Senegal', 
			'RS' => 'Serbia', 
			'SC' => 'Seychelles', 
			'SL' => 'Sierra Leone', 
			'SG' => 'Singapore', 
			'SK' => 'Slovakia', 
			'SI' => 'Slovenia', 
			'SB' => 'Solomon Islands', 
			'SO' => 'Somalia', 
			'ZA' => 'South Africa', 
			'GS' => 'South Georgia And Sandwich Isl.', 
			'ES' => 'Spain', 
			'LK' => 'Sri Lanka', 
			'SD' => 'Sudan', 
			'SR' => 'Suriname', 
			'SJ' => 'Svalbard And Jan Mayen', 
			'SZ' => 'Swaziland', 
			'SE' => 'Sweden', 
			'CH' => 'Switzerland', 
			'SY' => 'Syrian Arab Republic', 
			'TW' => 'Taiwan', 
			'TJ' => 'Tajikistan', 
			'TZ' => 'Tanzania', 
			'TH' => 'Thailand', 
			'TL' => 'Timor-Leste', 
			'TG' => 'Togo', 
			'TK' => 'Tokelau', 
			'TO' => 'Tonga', 
			'TT' => 'Trinidad And Tobago', 
			'TN' => 'Tunisia', 
			'TR' => 'Turkey', 
			'TM' => 'Turkmenistan', 
			'TC' => 'Turks And Caicos Islands', 
			'TV' => 'Tuvalu', 
			'UG' => 'Uganda', 
			'UA' => 'Ukraine', 
			'AE' => 'United Arab Emirates', 
			'GB' => 'United Kingdom', 
			'US' => 'United States', 
			'UM' => 'United States Outlying Islands', 
			'UY' => 'Uruguay', 
			'UZ' => 'Uzbekistan', 
			'VU' => 'Vanuatu', 
			'VE' => 'Venezuela', 
			'VN' => 'Viet Nam', 
			'VG' => 'Virgin Islands, British', 
			'VI' => 'Virgin Islands, U.S.', 
			'WF' => 'Wallis And Futuna', 
			'EH' => 'Western Sahara', 
			'YE' => 'Yemen', 
			'ZM' => 'Zambia', 
			'ZW' => 'Zimbabwe' 
	);
}

function braintree_get_states()
{
	return apply_filters( 'braintree_get_states', array (
			'AL' => __( 'Alabama', 'woocommerce' ), 
			'AK' => __( 'Alaska', 'woocommerce' ), 
			'AZ' => __( 'Arizona', 'woocommerce' ), 
			'AR' => __( 'Arkansas', 'woocommerce' ), 
			'CA' => __( 'California', 'woocommerce' ), 
			'CO' => __( 'Colorado', 'woocommerce' ), 
			'CT' => __( 'Connecticut', 'woocommerce' ), 
			'DE' => __( 'Delaware', 'woocommerce' ), 
			'DC' => __( 'District Of Columbia', 'woocommerce' ), 
			'FL' => __( 'Florida', 'woocommerce' ), 
			'GA' => _x( 'Georgia', 'US state of Georgia', 'woocommerce' ), 
			'HI' => __( 'Hawaii', 'woocommerce' ), 
			'ID' => __( 'Idaho', 'woocommerce' ), 
			'IL' => __( 'Illinois', 'woocommerce' ), 
			'IN' => __( 'Indiana', 'woocommerce' ), 
			'IA' => __( 'Iowa', 'woocommerce' ), 
			'KS' => __( 'Kansas', 'woocommerce' ), 
			'KY' => __( 'Kentucky', 'woocommerce' ), 
			'LA' => __( 'Louisiana', 'woocommerce' ), 
			'ME' => __( 'Maine', 'woocommerce' ), 
			'MD' => __( 'Maryland', 'woocommerce' ), 
			'MA' => __( 'Massachusetts', 'woocommerce' ), 
			'MI' => __( 'Michigan', 'woocommerce' ), 
			'MN' => __( 'Minnesota', 'woocommerce' ), 
			'MS' => __( 'Mississippi', 'woocommerce' ), 
			'MO' => __( 'Missouri', 'woocommerce' ), 
			'MT' => __( 'Montana', 'woocommerce' ), 
			'NE' => __( 'Nebraska', 'woocommerce' ), 
			'NV' => __( 'Nevada', 'woocommerce' ), 
			'NH' => __( 'New Hampshire', 'woocommerce' ), 
			'NJ' => __( 'New Jersey', 'woocommerce' ), 
			'NM' => __( 'New Mexico', 'woocommerce' ), 
			'NY' => __( 'New York', 'woocommerce' ), 
			'NC' => __( 'North Carolina', 'woocommerce' ), 
			'ND' => __( 'North Dakota', 'woocommerce' ), 
			'OH' => __( 'Ohio', 'woocommerce' ), 
			'OK' => __( 'Oklahoma', 'woocommerce' ), 
			'OR' => __( 'Oregon', 'woocommerce' ), 
			'PA' => __( 'Pennsylvania', 'woocommerce' ), 
			'RI' => __( 'Rhode Island', 'woocommerce' ), 
			'SC' => __( 'South Carolina', 'woocommerce' ), 
			'SD' => __( 'South Dakota', 'woocommerce' ), 
			'TN' => __( 'Tennessee', 'woocommerce' ), 
			'TX' => __( 'Texas', 'woocommerce' ), 
			'UT' => __( 'Utah', 'woocommerce' ), 
			'VT' => __( 'Vermont', 'woocommerce' ), 
			'VA' => __( 'Virginia', 'woocommerce' ), 
			'WA' => __( 'Washington', 'woocommerce' ), 
			'WV' => __( 'West Virginia', 'woocommerce' ), 
			'WI' => __( 'Wisconsin', 'woocommerce' ), 
			'WY' => __( 'Wyoming', 'woocommerce' ), 
			'AA' => __( 'Armed Forces (AA)', 'woocommerce' ), 
			'AE' => __( 'Armed Forces (AE)', 'woocommerce' ), 
			'AP' => __( 'Armed Forces (AP)', 'woocommerce' ) 
	) );
}

/**
 * Return true if the current page is the donation page.
 *
 * @return boolean
 */
function braintree_is_donation_page()
{
	global $post;
	if ( ! $post ) {
		return;
	}
	return has_shortcode( $post->post_content, 'braintree_donations' ) || has_shortcode( $post->post_content, 'braintree_recurring_donation' );
}

function braintree_create_donation( $args = array() )
{
	$args = wp_parse_args( $args, array (
			'donation_message' => '', 
			'first_name' => 'N/A', 
			'last_name' => 'N/A', 
			'billing_address1' => '', 
			'billing_address2' => '', 
			'billing_country' => '', 
			'billing_city' => '', 
			'billing_state' => '', 
			'email_address' => '', 
			'currency' => '' 
	) );
	$post_args = array (
			'post_title' => sprintf( __( 'Donation %s', 'braintree' ), strftime( '%b %d %Y @ %H %M %S', time() ) ), 
			'post_content' => '', 
			'post_excerpt' => '', 
			'post_type' => 'braintree_donation', 
			'post_status' => 'btd-processing', 
			'post_author' => 0 
	);
	$post_id = wp_insert_post( $post_args );
	foreach ( $args as $arg => $value ) {
		update_post_meta( $post_id, $arg, $value );
	}
	return $post_id;
}

function braintree_create_recurring_donation( $args = array() )
{
	$args = wp_parse_args( $args, array (
			'donation_message' => '', 
			'first_name' => 'N/A', 
			'last_name' => 'N/A', 
			'billing_address1' => '', 
			'billing_address2' => '', 
			'billing_country' => '', 
			'billing_city' => '', 
			'billing_state' => '', 
			'email_address' => '', 
			'currency' => '' 
	) );
	$post_args = array (
			'post_title' => sprintf( __( 'Donation %s', 'braintree' ), strftime( '%b %d %Y @ %H %M %S', time() ) ), 
			'post_content' => '', 
			'post_excerpt' => '', 
			'post_type' => 'bt_rc_donation', 
			'post_status' => 'btd-processing', 
			'post_author' => 0 
	);
	$post_id = wp_insert_post( $post_args );
	foreach ( $args as $arg => $value ) {
		update_post_meta( $post_id, $arg, $value );
	}
	return $post_id;
}

function braintree_update_donation( $post_id, $args = array() )
{
	foreach ( $args as $arg => $value ) {
		update_post_meta( $post_id, $arg, $value );
	}
}

/**
 * Return a donation object.
 *
 * @param WP_POST|int $post        	
 * @return Braintree_Gateway_Donation
 */
function braintree_get_donation( $post )
{
	return new Braintree_Gateway_Donation( $post );
}

function braintree_get_recurring_donation( $post )
{
	return new Braintree_Gateway_Recurring_Donation( $post );
}

function braintree_get_donation_statuses()
{
	return array (
			'btd-processing' => __( 'Processing', 'braintree' ), 
			'btd-complete' => __( 'Complete', 'braintree' ), 
			'btd-cancelled' => __( 'Cancelled', 'braintree' ) 
	);
}

function braintree_get_currency_symbol( $currency = 'USD' )
{
	$symbols = apply_filters( 'braintree_currency_symbols', array (
			'AED' => '&#x62f;.&#x625;', 
			'AFN' => '&#x60b;', 
			'ALL' => 'L', 
			'AMD' => 'AMD', 
			'ANG' => '&fnof;', 
			'AOA' => 'Kz', 
			'ARS' => '&#36;', 
			'AUD' => '&#36;', 
			'AWG' => '&fnof;', 
			'AZN' => 'AZN', 
			'BAM' => 'KM', 
			'BBD' => '&#36;', 
			'BDT' => '&#2547;&nbsp;', 
			'BGN' => '&#1083;&#1074;.', 
			'BHD' => '.&#x62f;.&#x628;', 
			'BIF' => 'Fr', 
			'BMD' => '&#36;', 
			'BND' => '&#36;', 
			'BOB' => 'Bs.', 
			'BRL' => '&#82;&#36;', 
			'BSD' => '&#36;', 
			'BTC' => '&#3647;', 
			'BTN' => 'Nu.', 
			'BWP' => 'P', 
			'BYR' => 'Br', 
			'BZD' => '&#36;', 
			'CAD' => '&#36;', 
			'CDF' => 'Fr', 
			'CHF' => '&#67;&#72;&#70;', 
			'CLP' => '&#36;', 
			'CNY' => '&yen;', 
			'COP' => '&#36;', 
			'CRC' => '&#x20a1;', 
			'CUC' => '&#36;', 
			'CUP' => '&#36;', 
			'CVE' => '&#36;', 
			'CZK' => '&#75;&#269;', 
			'DJF' => 'Fr', 
			'DKK' => 'DKK', 
			'DOP' => 'RD&#36;', 
			'DZD' => '&#x62f;.&#x62c;', 
			'EGP' => 'EGP', 
			'ERN' => 'Nfk', 
			'ETB' => 'Br', 
			'EUR' => '&euro;', 
			'FJD' => '&#36;', 
			'FKP' => '&pound;', 
			'GBP' => '&pound;', 
			'GEL' => '&#x10da;', 
			'GGP' => '&pound;', 
			'GHS' => '&#x20b5;', 
			'GIP' => '&pound;', 
			'GMD' => 'D', 
			'GNF' => 'Fr', 
			'GTQ' => 'Q', 
			'GYD' => '&#36;', 
			'HKD' => '&#36;', 
			'HNL' => 'L', 
			'HRK' => 'Kn', 
			'HTG' => 'G', 
			'HUF' => '&#70;&#116;', 
			'IDR' => 'Rp', 
			'ILS' => '&#8362;', 
			'IMP' => '&pound;', 
			'INR' => '&#8377;', 
			'IQD' => '&#x639;.&#x62f;', 
			'IRR' => '&#xfdfc;', 
			'ISK' => 'Kr.', 
			'JEP' => '&pound;', 
			'JMD' => '&#36;', 
			'JOD' => '&#x62f;.&#x627;', 
			'JPY' => '&yen;', 
			'KES' => 'KSh', 
			'KGS' => '&#x43b;&#x432;', 
			'KHR' => '&#x17db;', 
			'KMF' => 'Fr', 
			'KPW' => '&#x20a9;', 
			'KRW' => '&#8361;', 
			'KWD' => '&#x62f;.&#x643;', 
			'KYD' => '&#36;', 
			'KZT' => 'KZT', 
			'LAK' => '&#8365;', 
			'LBP' => '&#x644;.&#x644;', 
			'LKR' => '&#xdbb;&#xdd4;', 
			'LRD' => '&#36;', 
			'LSL' => 'L', 
			'LYD' => '&#x644;.&#x62f;', 
			'MAD' => '&#x62f;. &#x645;.', 
			'MAD' => '&#x62f;.&#x645;.', 
			'MDL' => 'L', 
			'MGA' => 'Ar', 
			'MKD' => '&#x434;&#x435;&#x43d;', 
			'MMK' => 'Ks', 
			'MNT' => '&#x20ae;', 
			'MOP' => 'P', 
			'MRO' => 'UM', 
			'MUR' => '&#x20a8;', 
			'MVR' => '.&#x783;', 
			'MWK' => 'MK', 
			'MXN' => '&#36;', 
			'MYR' => '&#82;&#77;', 
			'MZN' => 'MT', 
			'NAD' => '&#36;', 
			'NGN' => '&#8358;', 
			'NIO' => 'C&#36;', 
			'NOK' => '&#107;&#114;', 
			'NPR' => '&#8360;', 
			'NZD' => '&#36;', 
			'OMR' => '&#x631;.&#x639;.', 
			'PAB' => 'B/.', 
			'PEN' => 'S/.', 
			'PGK' => 'K', 
			'PHP' => '&#8369;', 
			'PKR' => '&#8360;', 
			'PLN' => '&#122;&#322;', 
			'PRB' => '&#x440;.', 
			'PYG' => '&#8370;', 
			'QAR' => '&#x631;.&#x642;', 
			'RMB' => '&yen;', 
			'RON' => 'lei', 
			'RSD' => '&#x434;&#x438;&#x43d;.', 
			'RUB' => '&#8381;', 
			'RWF' => 'Fr', 
			'SAR' => '&#x631;.&#x633;', 
			'SBD' => '&#36;', 
			'SCR' => '&#x20a8;', 
			'SDG' => '&#x62c;.&#x633;.', 
			'SEK' => '&#107;&#114;', 
			'SGD' => '&#36;', 
			'SHP' => '&pound;', 
			'SLL' => 'Le', 
			'SOS' => 'Sh', 
			'SRD' => '&#36;', 
			'SSP' => '&pound;', 
			'STD' => 'Db', 
			'SYP' => '&#x644;.&#x633;', 
			'SZL' => 'L', 
			'THB' => '&#3647;', 
			'TJS' => '&#x405;&#x41c;', 
			'TMT' => 'm', 
			'TND' => '&#x62f;.&#x62a;', 
			'TOP' => 'T&#36;', 
			'TRY' => '&#8378;', 
			'TTD' => '&#36;', 
			'TWD' => '&#78;&#84;&#36;', 
			'TZS' => 'Sh', 
			'UAH' => '&#8372;', 
			'UGX' => 'UGX', 
			'USD' => '&#36;', 
			'UYU' => '&#36;', 
			'UZS' => 'UZS', 
			'VEF' => 'Bs F', 
			'VND' => '&#8363;', 
			'VUV' => 'Vt', 
			'WST' => 'T', 
			'XAF' => 'Fr', 
			'XCD' => '&#36;', 
			'XOF' => 'Fr', 
			'XPF' => 'Fr', 
			'YER' => '&#xfdfc;', 
			'ZAR' => '&#82;', 
			'ZMW' => 'ZK' 
	) );
	
	$currency_symbol = isset( $symbols [ $currency ] ) ? $symbols [ $currency ] : '';
	return $currency_symbol;
}

function braintree_filter_sale_transactions( $transaction )
{
	return $transaction->type === Braintree_Transaction::SALE;
}

function braintree_filter_credit_transactions( $transaction )
{
	return $transaction->type === Braintree_Transaction::CREDIT;
}

/**
 * Echo an input field for a braintree payment_method_nonce.
 */
function braintree_nonce_field( $name = 'payment_method_nonce' )
{
	$field = '<input type="hidden" class="bfwc-nonce-value" id="' . $name . '" name="' . $name . '"/>';
	echo $field;
}

/**
 * Echo an input field for a braintree device data hidden field.
 *
 * @param string $name        	
 */
function braintree_device_data_field( $name = 'braintree_device_data' )
{
	$field = '<input type="hidden" class="bfwc-device-data" id="' . $name . '" name="' . $name . '"/>';
	echo $field;
}

/**
 * Return a custom message associated with the Braintree error code.
 *
 * @param number $code        	
 * @return string
 */
function braintree_get_error_code_message( $code = 0 )
{
	$errors = array (
			'91506' => __( 'Cannot refund a transaction unless it has a status of settled. To refund a partial amount, you must wait for the status to be updated. 
                    If you wish to refund the entire transaction then you can void the transaction.', 'braintree' ) 
	);
	return isset( $errors [ $code ] ) ? preg_replace( '/\s\s+/', ' ', $errors [ $code ] ) : '';
}

/**
 * Globalize the Braintree errors so they can be used throughout the
 * application.
 *
 * @param Braintree_Result_Error $result        	
 */
function braintree_global_errors( $result )
{
	global $braintree_result_errors;
	$braintree_result_errors = array ();
	foreach ( $result->errors->deepAll() as $error ) {
		$braintree_result_errors [] = $error->code;
	}
}

/**
 * Return an array of PayPal buttons.
 */
function braintree_get_paypal_buttons()
{
	return include bt_manager()->plugin_include_path() . 'paypal-buttons.php';
}

function braintree_get_custom_donation_forms()
{
	return include bt_manager()->plugin_include_path() . 'braintree-custom-donation-forms.php';
}