<?php
/**
 * 
 * @author Payment Plugins
 * @copyright 2016 Payment Plugins
 *
 */
class WC_Product_Braintree_Subscription_Variation extends WC_Product_Variation
{

	public function __construct( $variation, $args = array() )
	{
		$this->variation_id = $variation->ID;
		
		$this->id = ! empty( $args[ 'parent_id' ] ) ? intval( $args[ 'parent_id' ] ) : wp_get_post_parent_id( $this->variation_id );
		$this->parent = ! empty( $args[ 'parent' ] ) ? $args[ 'parent' ] : wc_get_product( $this->id );
		
		$this->product_type = $this->parent->product_type;
		$this->post = $this->parent->post;
	}

	public static function init()
	{
		add_filter( 'woocommerce_product_class', __CLASS__ . '::get_classname', 10, 4 );
	}

	public function get_price_html( $price = '' )
	{
		return bfwcs_get_product_price_html( $this, $price );
	}

	public static function get_classname( $classname, $product_type, $post_type, $product_id )
	{
		if ( $post_type === 'product_variation' ) {
			$post = get_post( $product_id );
			$terms = get_the_terms( $post->post_parent, 'product_type' );
			
			$parent_product_type = ! empty( $terms ) && isset( current( $terms )->slug ) ? current( $terms )->slug : '';
			
			if ( $parent_product_type === 'braintree-variable-subscription' ) {
				$classname = __CLASS__;
			}
		}
		return $classname;
	
	}

	public function get_signup_fee()
	{
		return $this->subscription_sign_up_fee ? $this->subscription_sign_up_fee : 0;
	}

	public function is_one_time_shipping()
	{
		return $this->parent->subscription_one_time_shipping === 'yes' && ! $this->subscription_trial_length;
	}
}
WC_Product_Braintree_Subscription_Variation::init();